var jxfamille;
(function (jxfamille) {
    var Accueil = (function () {
        function Accueil(element) {
            this.element = element;
            $(this.element).hide();
            $('#p1-bebe').hide();
            $('#p1-3age').hide();
            $('#p1-ado').hide();
        }
        Accueil.prototype.start = function () {
            $(this.element).fadeIn();
            $('#p1-bebe').fadeIn();
            $('#p1-3age').fadeIn();
            $('#p1-ado').fadeIn();
        };
        Accueil.prototype.stop = function () {
            $(this.element).fadeOut().hide();
            $('#p1-bebe').hide();
            $('#p1-3age').hide();
            $('#p1-ado').hide();
            console.log("Accueil hide", this);
        };
        return Accueil;
    }());
    jxfamille.Accueil = Accueil;
})(jxfamille || (jxfamille = {}));
var jxfamille;
(function (jxfamille) {
    var Intro = (function () {
        function Intro(element) {
            this.element = element;
        }
        Intro.prototype.start = function () {
            $(this.element).show();
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
            $('.info_intro').fadeIn();
            console.log("Intro start", this);
            $(this.element).find(".animation").fadeIn();
        };
        Intro.prototype.stop = function () {
            $(this.element).hide();
            $('.info_intro').fadeOut();
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 0 });
            console.log("Intro hide", this);
            $(this.element).find(".animation").fadeOut();
        };
        return Intro;
    }());
    jxfamille.Intro = Intro;
})(jxfamille || (jxfamille = {}));
var jxfamille;
(function (jxfamille) {
    var Evolution = (function () {
        function Evolution(element) {
            var _this = this;
            this.etapeMax = 15;
            this.min_chrono_x = 21;
            this.max_chrono_x = 75;
            this.arr_contraception = [1, 3, 3, 6, 20, 50, 50];
            this.listeClear = false;
            this.base_bebe_marginRight = -37;
            this.perdu_alpha = 0.1;
            this.potentiel_alpha = 0.2;
            this.desire_alpha = 1;
            this.ne_alpha = 1;
            this.ok_alpha = 1;
            this.prevRisques = 0;
            this.element = element;
            this.n_puberte = 15;
            this.max_allaitement = 99;
            this.n_sterilite = 0;
            this.max_sterilite = 50;
            this.n_mariage = 15;
            this.n_allaitement = 0;
            this.max_desire = 23;
            this.n_desire = 2;
            this.n_contraception = 0;
            this.selected_contraception = -1;
            this.step_chrono = (this.max_chrono_x - this.min_chrono_x) / (this.max_sterilite - this.n_puberte);
            this.addlisteners();
            this.n_sterilite = this.max_sterilite;
            document.getElementById('b_contraception').selectedIndex = 0;
            this._hideAllStartId();
            this.updateShowid(0);
            this.onResize();
            $(window);
            $(window).on("resize", function (event) { return _this.onResize(); });
        }
        Evolution.prototype.start = function () {
            this.updateCompteurs();
            $(this.element).fadeIn();
            this.currentEtape = 0;
            this._hideAllStartId();
            this.updateShowid(0);
            this.incrementalRestore();
            this.onResize();
        };
        Evolution.prototype.show = function () {
            $(this.element).fadeIn();
            this.onResize();
        };
        Evolution.prototype.hide = function () {
            $(this.element).fadeOut();
            this.onResize();
        };
        Evolution.prototype.stop = function () {
            $(this.element).fadeOut();
            this._hideAllStartId();
        };
        Evolution.prototype.addlisteners = function () {
            var _this = this;
            tools.MouseTools.addClickListener(document.getElementById('b_sterilite'), function (event) { return _this.on_click_b_sterilite(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_mariagep'), function (event) { return _this.on_click_b_mariagep(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_mariagem'), function (event) { return _this.on_click_b_mariagem(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_allaitementp'), function (event) { return _this.on_click_b_allaitementp(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_allaitementm'), function (event) { return _this.on_click_b_allaitementm(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_desirep'), function (event) { return _this.on_click_b_desirep(event); });
            tools.MouseTools.addClickListener(document.getElementById('b_desirem'), function (event) { return _this.on_click_b_desirem(event); });
            tools.MouseTools.addSelectListener(document.getElementById('b_contraception'), function (event) { return _this.on_click_b_contraception(event); });
        };
        Evolution.prototype.on_click_b_sterilite = function (e) {
            this.n_sterilite = Math.floor(Math.random() * 11 + 39);
            this.updateCompteurs();
            _gameController.progress_activite(6);
        };
        Evolution.prototype.on_click_b_mariagep = function (e) {
            if (this.n_mariage < 60) {
                this.n_mariage += 1;
            }
            this.updateCompteurs();
            _gameController.progress_activite(9);
        };
        Evolution.prototype.on_click_b_mariagem = function (e) {
            if (this.n_mariage > this.n_puberte) {
                this.n_mariage -= 1;
            }
            this.updateCompteurs();
            _gameController.progress_activite(9);
        };
        Evolution.prototype.updateTxtMariage = function () {
            var chaine;
            if (_gameController.currentSex_h) {
                if (this.n_mariage >= this.n_sterilite) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h0'];
                }
                else if (this.n_potentiel > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h'];
                }
                else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_h1'];
                }
            }
            else {
                if (this.n_mariage >= this.n_sterilite) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f0'];
                }
                else if (this.n_potentiel > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f'];
                }
                else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_ans_lors_du_mariage_f1'];
                }
            }
            var texte = tools.TokenUtil.replaceTokens(chaine, { age: this.n_mariage.toString(), reduit: this.getBabiesBeforeMariage().toString(), potentiel: this.n_potentiel.toString() });
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_ans_lors_du_mariage", texte);
        };
        Evolution.prototype.on_click_b_allaitementp = function (e) {
            if (this.n_allaitement < this.max_allaitement) {
                this.n_allaitement += 1;
            }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_allaitementm = function (e) {
            if (this.n_allaitement > 0) {
                this.n_allaitement -= 1;
            }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_desirep = function (e) {
            this.n_desire += 1;
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_desirem = function (e) {
            if (this.n_desire > 0) {
                this.n_desire -= 1;
            }
            this.updateCompteurs();
        };
        Evolution.prototype.on_click_b_contraception = function (e) {
            if (!this.listeClear) {
                this.listeClear = true;
                this.parentDefault = $('#b_contraception_default').parent().first();
                this.removedDefault = $('#b_contraception_default').remove();
            }
            var index = document.getElementById('b_contraception').selectedIndex;
            console.log("on_click_b_contraception ", index);
            this.selected_contraception = index;
            this.updateCompteurs();
            TweenMax.to(document.getElementsByClassName('ss_txt_compteur'), 0.5, { autoAlpha: 1 });
            _gameController.progress_activite(14);
        };
        Evolution.prototype.incrementalRestore = function () {
            if (this.currentEtape <= 13) {
                this.selected_contraception = -1;
                if (this.listeClear) {
                    this.listeClear = false;
                    this.parentDefault.prepend(this.removedDefault);
                    document.getElementById('b_contraception').selectedIndex = 0;
                }
            }
            if (this.currentEtape <= 0) {
                this.n_desire = 2;
            }
            if (this.currentEtape <= 10) {
                this.n_allaitement = 0;
            }
            if (this.currentEtape <= 6) {
                this.n_mariage = 15;
            }
            if (this.currentEtape <= 5) {
                this.n_sterilite = this.max_sterilite;
            }
            if (this.currentEtape >= 0) {
                this.updateCompteurs();
            }
        };
        Evolution.prototype.updateShowid = function (id) {
            var prevEtape = this.currentEtape;
            this.currentEtape = id;
            console.log("updateShowid ", id, this);
            if (this.currentEtape == 7) {
                this.n_mariage = 23;
                this.updateCompteurs();
            }
            if (prevEtape > this.currentEtape) {
                this.incrementalRestore();
            }
            for (var i = 0; i < this.etapeMax; i++) {
                if (i != id) {
                    this._hideId(i);
                }
                if (id < i) {
                    this._hideStartId(i);
                }
            }
            for (var i = 0; i < this.etapeMax; i++) {
                if (i == id) {
                    this._showId(i);
                }
                if (id >= i) {
                    this._showStartId(i);
                }
            }
            this.updateBebeList();
            this.onResize();
        };
        Evolution.prototype.onResize = function () {
            TweenMax.to(document.getElementById('liste_bebe'), 0.5, { left: this.min_chrono_x + "%" });
            var deltaPos = ($('#box_menopause').offset().left - 10) - $('#box_regles').offset().left;
            var arr_bab = tools.MouseTools.toArray(document.getElementById("liste_bebe").getElementsByTagName("img"));
            var bebEspace = -37 + deltaPos / arr_bab.length;
            TweenMax.staggerTo(arr_bab, 0, { css: { marginRight: bebEspace } }, 0.01);
        };
        Evolution.prototype.updateBebeList = function () {
            var x_mariage = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_mariage - this.n_puberte));
            var arr_bab = tools.MouseTools.toArray(document.getElementById("liste_bebe").getElementsByTagName("img"));
            if (this.currentEtape == 0) {
                TweenMax.staggerTo(arr_bab, 0, { autoAlpha: 0 }, 0.01);
                return;
            }
            if (this.currentEtape > 1) {
                var nb_max = this.getBabiesPotentielMax();
                var step = nb_max / this.n_potentiel;
                var arr_potentiel = [];
                arr_potentiel = arr_bab.splice(this.getBabiesBeforeMariage(), this.n_potentiel);
                if (this.currentEtape < 11) {
                    TweenMax.staggerTo(arr_bab.reverse(), 0, { autoAlpha: this.perdu_alpha }, 0.01);
                    TweenMax.staggerTo(arr_potentiel, 0, { autoAlpha: this.ne_alpha }, 0.01);
                }
                else {
                    var arr_ne = arr_potentiel.slice(0, this.n_ne);
                    var arr_desire = arr_ne.slice(0, this.n_desire);
                    TweenMax.staggerTo(arr_bab.reverse(), 0, { autoAlpha: this.perdu_alpha }, 0.01);
                    TweenMax.staggerTo(arr_potentiel, 0, { autoAlpha: this.potentiel_alpha }, 0.01);
                    TweenMax.staggerTo(arr_ne, 0, { autoAlpha: this.ne_alpha }, 0.01);
                    TweenMax.staggerTo(arr_desire, 0, { autoAlpha: this.desire_alpha }, 0.01);
                }
            }
        };
        Evolution.prototype.etape_0 = function () {
            this.updateShowid(0);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_1 = function () {
            this.updateShowid(1);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_2 = function () {
            this.updateShowid(2);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_3 = function () {
            this.updateShowid(3);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_4 = function () {
            this.updateShowid(4);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_5 = function () {
            this.updateShowid(5);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_6 = function () {
            this.updateShowid(6);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_7 = function () {
            this.updateShowid(7);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_8 = function () {
            this.updateShowid(8);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_9 = function () {
            this.updateShowid(9);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_10 = function () {
            this.updateShowid(10);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_11 = function () {
            this.updateShowid(11);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_12 = function () {
            this.updateShowid(12);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_13 = function () {
            this.updateShowid(13);
            TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
        };
        Evolution.prototype.etape_14 = function () {
            this.updateShowid(14);
            TweenMax.to(document.getElementsByClassName('suite'), 0, { autoAlpha: 0 });
        };
        Evolution.prototype._showId = function (id) {
            console.log("_showId ", id, this);
            $('.display_' + id).css("display", "block");
            $('.info_' + id + ".toggle").stop().show();
            $('.info_' + id).not(".toggle").stop().fadeIn();
        };
        Evolution.prototype._hideId = function (id) {
            console.log("_hideId ", id, this);
            $('.display_' + id).css("display", "none");
            $('.info_' + id + ".toggle").not('.info_' + this.currentEtape).stop().hide();
            $('.info_' + id).not(".toggle").not('.info_' + this.currentEtape).stop().fadeOut();
        };
        Evolution.prototype._showStartId = function (id) {
            $('.display_start_' + id).css("display", "block");
            $('.info_start_' + id).stop().show();
        };
        Evolution.prototype._hideStartId = function (id) {
            $('.display_start_' + id).css("display", "none");
            $('.info_start_' + id).stop().hide();
        };
        Evolution.prototype._hideAllStartId = function () {
            for (var i = 0; i < this.etapeMax; i++) {
                $('.display_start_' + i).css("display", "block");
                $('.info_start_' + i).stop().show();
            }
        };
        Evolution.prototype.compteurCallBack = function () {
            console.log("compteurCallBack");
        };
        Evolution.prototype.updateCompteurs = function () {
            var _this = this;
            if ((this.currentEtape + 1) < this.etapeMax) {
                TweenMax.to(document.getElementsByClassName('suite'), 0.5, { autoAlpha: 1 });
            }
            $('#c_sterilite').compteur({ target: this.n_sterilite, callback: this.compteurCallBack });
            var x_sterilite = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_sterilite - this.n_puberte));
            TweenMax.to(document.getElementById('box_sterilite'), 0.5, { left: x_sterilite + "%" });
            $('#c_mariage').compteur({ target: this.n_mariage });
            $('#c_allaitement').compteur({ target: this.n_allaitement });
            this.updateBabesPotentiel();
            $('#c_desire').compteur({ target: this.n_desire });
            this.updateBabesDesire();
            this.n_contraception = this.getBabiesByContraception();
            $('#c_contraception').compteur({ target: this.n_contraception });
            $('.nb_enfantsSup').html(this.n_contraception.toString());
            this.updateBabesne();
            $('.n_sterilite').each(function (i, item) {
                item.innerHTML = _this.n_sterilite.toString();
            });
            $('.n_mariage').each(function (i, item) {
                item.innerHTML = _this.n_mariage.toString();
            });
            $('.n_desire').each(function (i, item) {
                item.innerHTML = _this.n_desire.toString();
            });
            $('.n_reduit').each(function (i, item) {
                item.innerHTML = (_this.max_desire - _this.n_potentiel).toString();
            });
            var x_mariage = Math.floor(this.min_chrono_x + this.step_chrono * (this.n_mariage - this.n_puberte));
            TweenMax.to(document.getElementById('box_mariage'), 0.5, { left: x_mariage + "%" });
            this.updateBebeList();
            if (this.n_desire > this.n_potentiel && $("#c_desire").css("display") != "none") {
                $(".c_desire.infobulle").queue("fx", []).stop();
                $(".c_desire.infobulle").fadeIn().delay(2000).fadeOut();
            }
            this.updateTxtContraception();
            this.updateTxtCapacite();
            this.updateTxtEnPlus();
            this.updateTxtMariage();
        };
        Evolution.prototype.getContraceptionRisque = function () {
            var index = Math.max(document.getElementById('b_contraception').selectedIndex, 0);
            return this.arr_contraception[index];
        };
        Evolution.prototype.getBabiesByContraception = function () {
            var babMorePossibles = Math.max(0, this.getBabiesPotentiel() - this.n_desire);
            if (this.selected_contraception == -1) {
                this.prevRisques = 100;
                return babMorePossibles;
            }
            var pcRisque = this.getContraceptionRisque() * babMorePossibles / 100;
            var ret = Math.round(pcRisque);
            ret = Math.round((Math.random() * ret * 0.5) + (ret * 0.5));
            if (this.prevRisques != pcRisque) {
                this.prevRisques = pcRisque;
                return (ret);
            }
            else {
                return this.n_contraception;
            }
        };
        Evolution.prototype.getAllaitementMonths = function () {
            return Math.max(18, (18 + this.n_allaitement * 2 / 3 - 2));
        };
        Evolution.prototype.getBabiesPotentiel = function () {
            var _loc1 = Math.round((this.n_sterilite - this.n_mariage) * 12 / this.getAllaitementMonths());
            return (_loc1 >= 0 ? (_loc1) : (0));
        };
        Evolution.prototype.getBabiesBeforeMariage = function () {
            return Math.min(Math.round((this.n_mariage - this.n_puberte) * 12 / 18), this.max_desire - this.getBabiesPotentiel());
        };
        Evolution.prototype.getBabiesPotentielMax = function () {
            return Math.round((this.n_sterilite - this.n_mariage) * 12 / 18);
        };
        Evolution.prototype.updateBabesDesire = function () {
            var pot = this.n_desire;
            console.log("updateBabesDesire ", pot);
            $('.n_desire').each(function (i, item) {
                item.innerHTML == pot.toString();
                ;
            });
        };
        Evolution.prototype.updateBabesPotentiel = function () {
            var _this = this;
            var pot = this.getBabiesPotentiel();
            console.log("updateBabesPotentiel ", pot);
            this.n_potentiel = pot;
            $('.n_potentiel').each(function (i, item) {
                item.innerHTML = pot.toString();
                ;
            });
            $('.n_supp').each(function (i, item) {
                item.innerHTML = (pot - _this.n_desire).toString();
                ;
            });
        };
        Evolution.prototype.updateTxtCapacite = function () {
            var n_reduit = (this.max_desire - this.n_potentiel);
            var chaine;
            chaine = jxfamille.GameController.xmlString.dico['famille_votre_capacite_sterile'];
            if (_gameController.currentSex_h) {
                if (n_reduit > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_h'];
                }
                else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_h1'];
                }
                if (this.n_potentiel > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_h'];
                }
                else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_h1'];
                }
            }
            else {
                if (n_reduit > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_f'];
                }
                else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_f1'];
                }
                if (this.n_potentiel > 1) {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_f'];
                }
                else {
                    chaine += jxfamille.GameController.xmlString.dico['famille_votre_capacite_potentiel_f1'];
                }
            }
            var texte = tools.TokenUtil.replaceTokens(chaine, { n_sterilite: this.n_sterilite.toString(), n_reduit: n_reduit.toString(), n_potentiel: this.n_potentiel.toString() });
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_votre_capacite", texte);
            var chaine3 = jxfamille.GameController.xmlString.dico['famille_texte_3'];
            var texte3 = tools.TokenUtil.replaceTokens(chaine3, { n_potentiel: this.n_potentiel.toString() });
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_texte_3", texte3);
        };
        Evolution.prototype.updateTxtContraception = function () {
            var n_supp = this.n_potentiel - this.n_desire;
            var chaine;
            if (n_supp <= 0) {
                chaine = jxfamille.GameController.xmlString.dico['famille_contraception_pas_limitation'];
            }
            else {
                if (this.n_desire > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_sans_contraception'];
                }
                else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_sans_contraception1'];
                }
            }
            var texte = tools.TokenUtil.replaceTokens(chaine, { n_desire: this.n_desire.toString(), n_supp: n_supp.toString() });
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_sans_contraception", texte);
        };
        Evolution.prototype.updateTxtEnPlus = function () {
            console.log("updateTxtEnPlus this.selected_contraception", this.selected_contraception);
            var chaine;
            var txtContraception;
            if (this.selected_contraception == -1) {
                if (this.n_contraception > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebes_en_plus_sans'];
                }
                else if (this.n_contraception > 0) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebe_en_plus_sans'];
                }
                else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_pas_bebe_en_plus_sans'];
                }
                txtContraception = "";
            }
            else {
                if (this.selected_contraception == 0) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_pas_bebe_en_plus_sans'];
                }
                else if (this.n_contraception > 1) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebes_en_plus'];
                }
                else if (this.n_contraception > 0) {
                    chaine = jxfamille.GameController.xmlString.dico['famille_titre_bebe_en_plus'];
                }
                else {
                    chaine = jxfamille.GameController.xmlString.dico['famille_pas_bebe_en_plus'];
                }
                txtContraception = jxfamille.GameController.xmlString.dico['famille_contraception' + this.selected_contraception];
            }
            console.log("updateTxtEnPlus this.selected_contraception", this.selected_contraception, txtContraception);
            var texte = tools.TokenUtil.replaceTokens(chaine, { nb_enfantsSup: this.n_contraception.toString(), txtMethode: txtContraception });
            jxfamille.GameController.xmlString.processElements("data-txt", "famille_titre_bebes_en_plus", texte);
        };
        Evolution.prototype.updateBabesne = function () {
            var pot = this.n_contraception + Math.min(this.n_desire, this.n_potentiel);
            console.log("updateBabesne ", pot);
            this.n_ne = pot;
            $('.n_ne').each(function (i, item) {
                item.innerHTML = pot.toString();
                ;
            });
        };
        return Evolution;
    }());
    jxfamille.Evolution = Evolution;
})(jxfamille || (jxfamille = {}));
var jxfamille;
(function (jxfamille) {
    var Progress = (function () {
        function Progress(element) {
            this.element = element;
            $(this.element).hide();
        }
        Progress.prototype.start = function () {
            $(this.element).show();
            this.list = this.element.getElementsByTagName("a");
            this.select(0);
        };
        Progress.prototype.stop = function () {
            $(this.element).hide();
            console.log("Intro hide", this);
        };
        Progress.prototype.select = function (id) {
            $(this.list).removeClass("selected");
            $(this.list.item(id)).addClass("selected");
        };
        return Progress;
    }());
    jxfamille.Progress = Progress;
})(jxfamille || (jxfamille = {}));
var jxfamille;
(function (jxfamille) {
    var Activite = (function () {
        function Activite(element) {
            this.maxEtape = 17;
            this._current = 0;
            this.element = element;
            this._progess = new jxfamille.Progress(document.getElementById('p3-progress'));
            this._intro = new jxfamille.Intro(document.getElementById('p3-intro'));
            this._Evolution = new jxfamille.Evolution(document.getElementById('p3-evolution'));
            $(this.element).hide();
            this.addlisteners();
        }
        Activite.prototype.addlisteners = function () {
            var _this = this;
            $('.suite').on("click", function (event) { return _this.on_click_suite(event); });
            $('.retour').on("click", function (event) { return _this.on_click_retour(event); });
        };
        Activite.prototype.on_click_suite = function (e) {
            this.select(this._current + 1);
        };
        Activite.prototype.on_click_retour = function (e) {
            if (this._current == 0) {
                this.select(0);
            }
            else {
                this.select(this._current - 1);
            }
        };
        Activite.prototype.start = function () {
            console.log("Activite start");
            $(this.element).show();
            TweenMax.to(document.getElementsByClassName('retour'), 0, { autoAlpha: 0 });
            this._current = 0;
            this._progess.stop();
            this.select(0);
        };
        Activite.prototype.stop = function () {
            this._progess.stop();
            this._intro.stop();
            this._Evolution.stop();
            $(this.element).hide();
        };
        Activite.prototype.progress_to = function (index) {
            if (index > this._current) {
                this.select(index);
            }
        };
        Activite.prototype.select = function (id) {
            var prev_current = this._current;
            this._current = id;
            console.log("Activite select ->", this._current);
            this._intro.stop();
            if (prev_current == 1 && this._current > 1) {
                this._Evolution.show();
            }
            switch (this._current) {
                case 0:
                    this._progess.start();
                    this._Evolution.stop();
                    this._Evolution.start();
                    this._Evolution.etape_0();
                    break;
                case 1:
                    this._progess.select(0);
                    this._Evolution.hide();
                    this._intro.start();
                    break;
                case 2:
                    this._progess.select(1);
                    this._Evolution.show();
                    this._Evolution.etape_1();
                    break;
                case 3:
                    this._progess.select(1);
                    this._Evolution.etape_2();
                    break;
                case 4:
                    this._progess.select(1);
                    this._Evolution.etape_3();
                    break;
                case 5:
                    this._progess.select(1);
                    this._Evolution.etape_4();
                    break;
                case 6:
                    this._progess.select(1);
                    this._Evolution.etape_5();
                    break;
                case 7:
                    this._progess.select(2);
                    this._Evolution.etape_6();
                    break;
                case 8:
                    this._progess.select(2);
                    this._Evolution.etape_7();
                    break;
                case 9:
                    this._progess.select(2);
                    this._Evolution.etape_8();
                    break;
                case 10:
                    this._progess.select(3);
                    this._Evolution.etape_9();
                    break;
                case 11:
                    this._progess.select(3);
                    this._Evolution.etape_10();
                    break;
                case 12:
                    this._progess.select(4);
                    this._Evolution.etape_11();
                    break;
                case 13:
                    this._progess.select(4);
                    this._Evolution.etape_12();
                    break;
                case 14:
                    this._progess.select(4);
                    this._Evolution.etape_13();
                    break;
                case 15:
                    this._progess.select(5);
                    this._Evolution.etape_14();
                    break;
                case 16:
                    break;
                default:
            }
            if (this._current == 0) {
                TweenMax.to(document.getElementsByClassName('retour'), 0, { autoAlpha: 0 });
            }
            else {
                TweenMax.to(document.getElementsByClassName('retour'), 0, { autoAlpha: 1 });
            }
        };
        return Activite;
    }());
    jxfamille.Activite = Activite;
})(jxfamille || (jxfamille = {}));
var jxfamille;
(function (jxfamille) {
    var ChoixSex = (function () {
        function ChoixSex(element) {
            this.element = element;
            $(this.element).hide();
            $('#p2_titre').hide();
            $('#p2-p3-btn-h').hide();
            $('#p2-p3-btn-f').hide();
        }
        ChoixSex.prototype.start = function () {
            $(this.element).show();
            $('#p2_titre').fadeIn();
            $('#p2-p3-btn-h').fadeIn();
            $('#p2-p3-btn-f').fadeIn();
        };
        ChoixSex.prototype.stop = function () {
            $(this.element).hide();
            $('#p2_titre').hide();
            $('#p2-p3-btn-h').hide();
            $('#p2-p3-btn-f').hide();
            console.log("ChoixSex hide", this);
        };
        return ChoixSex;
    }());
    jxfamille.ChoixSex = ChoixSex;
})(jxfamille || (jxfamille = {}));
var tools;
(function (tools) {
    var MouseTools = (function () {
        function MouseTools() {
        }
        MouseTools.addClickListener = function (elt, callback) {
            elt.onclick = function (event) { return callback(event); };
        };
        MouseTools.addClickListenerList = function (elt, callback) {
            for (var i = 0; i < elt.length; i++) {
                this.addClickListener(elt[i], callback);
            }
        };
        MouseTools.toArray = function (e) {
            return [].slice.call(e);
        };
        MouseTools.addSelectListener = function (elt, callback) {
            elt.onchange = function (event) { return callback(event); };
        };
        return MouseTools;
    }());
    tools.MouseTools = MouseTools;
})(tools || (tools = {}));
var jxfamille;
(function (jxfamille) {
    var GameController = (function () {
        function GameController(element) {
            this.element = element;
            this._accueil = new jxfamille.Accueil(document.getElementById('p1'));
            this._choixSex = new jxfamille.ChoixSex(document.getElementById('p2'));
            this._activite = new jxfamille.Activite(document.getElementById('p3'));
            this.addlisteners();
        }
        GameController.prototype.addlisteners = function () {
            var _this = this;
            var btn_p1_p2 = document.getElementById('p1-p2-btn');
            tools.MouseTools.addClickListener(btn_p1_p2, function (event) { return _this.on_click_p1_p2(event); });
            tools.MouseTools.addClickListener(document.getElementById('p2-p3-btn-h'), function (event) { return _this.on_click_p2_p3_h(event); });
            tools.MouseTools.addClickListener(document.getElementById('p2-p3-btn-f'), function (event) { return _this.on_click_p2_p3_f(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-intro-btn'), function (event) { return _this.on_click_p3_intro(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-sterilite-btn'), function (event) { return _this.on_click_p3_sterilite(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-couple-btn'), function (event) { return _this.on_click_p3_couple(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-allait-btn'), function (event) { return _this.on_click_p3_allait(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-contraception-btn'), function (event) { return _this.on_click_p3_contraception(event); });
            tools.MouseTools.addClickListener(document.getElementById('p3-conclusion-btn'), function (event) { return _this.on_click_p3_conclusion(event); });
        };
        GameController.prototype.start = function () {
            $(".h").remove();
            this.currentSex_h = false;
            GameController.xmlString.initGenericText();
            this._accueil.start();
            this._choixSex.stop();
            this._activite.stop();
        };
        GameController.prototype.on_click_p1_p2 = function (e) {
            this._accueil.stop();
            this._activite.start();
        };
        GameController.prototype.on_click_p2_p3_h = function (e) {
            this.currentSex_h = true;
            $(".f").remove();
            this._choixSex.stop();
            this._activite.start();
        };
        GameController.prototype.on_click_p2_p3_f = function (e) {
            $(".h").remove();
            this.currentSex_h = false;
            this._choixSex.stop();
            this._activite.start();
        };
        GameController.prototype.on_click_p3_intro = function (e) {
            this._choixSex.stop();
            this._activite.start();
        };
        GameController.prototype.on_click_p3_sterilite = function (e) {
            this._activite.select(2);
        };
        GameController.prototype.on_click_p3_couple = function (e) {
            this._activite.select(7);
        };
        GameController.prototype.on_click_p3_allait = function (e) {
            this._activite.select(10);
        };
        GameController.prototype.on_click_p3_contraception = function (e) {
            this._activite.select(13);
        };
        GameController.prototype.on_click_p3_conclusion = function (e) {
            this._activite.select(15);
        };
        GameController.prototype.progress_activite = function (index) {
            this._activite.progress_to(index);
        };
        return GameController;
    }());
    jxfamille.GameController = GameController;
})(jxfamille || (jxfamille = {}));
var tools;
(function (tools) {
    var XmlString = (function () {
        function XmlString(callBack) {
            this.callBack = callBack;
            this.dico = {};
        }
        XmlString.prototype.loadLang = function (filename) {
            $.ajax({
                context: this,
                type: "GET",
                url: filename + ".xml",
                dataType: "xml",
                error: this.onLangError,
                success: this.onLangLoaded
            });
        };
        XmlString.prototype.onLangLoaded = function (xml) {
            console.log("onLangLoaded ", xml);
            var list = xml.getElementsByTagName("item");
            for (var i = 0; i < list.length; i++) {
                var item = list.item(i);
                var oAt = item.attributes.getNamedItem("_title");
                if (oAt != null) {
                    oAt.value;
                    item.textContent;
                    this.dico[oAt.value] = item.textContent;
                }
            }
            this.callBack();
        };
        XmlString.prototype.initGenericText = function () {
            for (var v in this.dico) {
                this.processElements("data-txt", v, this.dico[v]);
            }
        };
        XmlString.prototype.processElements = function (attribute, template, data) {
            var _this = this;
            var toFind = "[" + attribute + "='" + template + "']";
            $("[" + attribute + "='" + template + "']").each(function (i, item) {
                _this.applyTemplateon(i, item, data);
            });
        };
        XmlString.prototype.applyTemplateon = function (i, item, data) {
            item.innerHTML = data;
        };
        XmlString.prototype.onLangError = function () {
            console.log("onLangError ");
        };
        return XmlString;
    }());
    tools.XmlString = XmlString;
})(tools || (tools = {}));
var tools;
(function (tools) {
    var TokenUtil = (function () {
        function TokenUtil() {
        }
        TokenUtil.CURLY_BRACES_PATTERN = function () { return /\$\{([\w'-]+)\}/g; };
        TokenUtil.BRACKET_PATTERN = function () { return /\$\[([\w'-]+)\]/g; };
        TokenUtil.replaceTokens = function (text, paramObj, replaceUndefineds, overrideRegEx) {
            if (paramObj === void 0) { paramObj = null; }
            if (replaceUndefineds === void 0) { replaceUndefineds = ""; }
            if (overrideRegEx === void 0) { overrideRegEx = null; }
            if (!paramObj) {
                return text;
            }
            else {
                var myRegEx = overrideRegEx ? overrideRegEx : this.CURLY_BRACES_PATTERN();
                var cleanText = text.replace(myRegEx, function (substring) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return paramObj[args[0]];
                });
                cleanText = cleanText.replace(/undefined/gi, function (substring) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return replaceUndefineds;
                });
                return cleanText;
            }
        };
        return TokenUtil;
    }());
    tools.TokenUtil = TokenUtil;
})(tools || (tools = {}));
function getParam(param) {
    var spath = window.location.search.split("&"), i;
    for (i = 0; i < spath.length; ++i) {
        var hash = spath[i].split("=");
        var hash_param = hash[0].replace("?", "");
        var hash_val = hash[1];
        if (hash_param == param) {
            return hash_val;
        }
    }
}
function onReady() {
    $("#loading").hide().remove();
    _gameController.start();
}
;
var _gameController;
var xmlString;
$(document).ready(function () {
    _gameController = new jxfamille.GameController(document.getElementById("famille"));
    jxfamille.GameController.xmlString = new tools.XmlString(onReady);
    $("<img />")
        .attr({ src: "img/loader.gif", alt: "chargement" })
        .load(function () {
        $(this).remove();
    });
    $('img').on('dragstart', function (event) { event.preventDefault(); });
});
window.onload = function () {
    var lg = getParam("lang") ? getParam("lang") : "fr";
    jxfamille.GameController.xmlString.loadLang(lg);
    var testTocken = tools.TokenUtil.replaceTokens("test ${test1}", { test1: "textToken" });
    console.log("testTocken ", testTocken);
};
console = { log: function () { } };
if (typeof console == "undefined" || typeof console.log == "undefined")
    console = { log: function () { } };
//# sourceMappingURL=app.js.map